import 'package:entity_repositories/entity_repository.dart';
import 'package:entity_repositories_example/models/address.dart';
import 'package:entity_repositories_example/models/car.dart';
import 'package:entity_repositories_example/models/person.dart';
import 'package:entity_repositories_example/models/song.dart';
import 'package:entity_repositories_example/models/tag.dart';

Future<void> daosInit() async {
  Hive
    ..init('./hive_test')
    ..registerAdapter<IndexImpl>(IndexAdapter())
    ..registerAdapter<Set>(SetAdapter())
    ..registerAdapter<Person>($PersonAdapter())
    ..registerAdapter<Address>($AddressAdapter())
    ..registerAdapter<Car>($CarAdapter())
    ..registerAdapter<Song>($SongAdapter())
    ..registerAdapter<Tag>($TagAdapter());

  /// First Register all daos and as hive adapters
  /// should it be done by Type?
  repositoryLocator
    ..registerDao<Person>($PersonRepo())
    ..registerDao<Address>($AddressRepo())
    ..registerDao<Car>($CarRepo())
    ..registerDao<Song>($SongRepo())
    ..registerDao<Tag>($TagRepo());

  // init all daos, will open the boxes
  await repositoryLocator.initAll();
}

Future<void> daoDispose() async {
  await repositoryLocator.disposeAll();

  /// TODO: indexbox dispose!
}
